<?php

class Entity_Carerix_EmployeeEducation {

    private $postValues = array();
    private $employeeEducations = null;
    private static $count = 0;
    
    private $values = array(
        'education' => '',
        'education_1' => '',
        'education_2' => '',
        'institute' => '',
        'yearStart' => '',
        'yearEnd' => ''
    );

    public function __construct($values, $employee) {
        $this->postValues = $values;
        $this->employeeEducations = $employee;
    }
    
    public function getData() {

        /**
         * empty data
         */
        if(count($this->postValues) <= 0 && $this->employeeEducations === null) {
            self::$count++;
            return $this->values;
        }
        
        /**
         * there are some post data. Post data has priority over carerix data
         */
        if(count($this->postValues) > 0) {
            
            foreach($this->values as $fieldName => &$value) {
                if(   isset($this->postValues[$fieldName])
                   && isset($this->postValues[$fieldName][self::$count])) {
                    $value = $this->postValues[$fieldName][self::$count];
                }
            }
            
            self::$count++;
            return $this->values;
        }
        
        /**
         * if it reached this point, there are no post data, carerix data has 
         * priority
         */
        if(   $this->employeeEducations !== null 
           && isset($this->employeeEducations[self::$count])) {
            
            /** @var Carerix_Api_Rest_Entity_CRWorkHistory ToDo */
            $education = $this->employeeEducations[self::$count];

            foreach($this->values as $fieldName => &$value) {
                switch($fieldName) {
                    case 'education':
                        $node = $education->getToLevel1Education1();
                        $value = '';
                        if($node) {
                            $value = $education->getToLevel1Education1()->getId();   
                        }
                        break;
                    case 'education_1':
                        $node = $education->getToLevel1Education2();
                        $value = '';
                        if($node) {
                            $value = $education->getToLevel1Education2()->getId();   
                        }
                    break;
                    case 'education_2':
                        $node = $education->getToLevel1Education3();
                        $value = '';
                        if($node) {
                            $value = $education->getToLevel1Education3()->getId();   
                        }
                    break;
                    case 'institute':
                        $value = $education->getInstitute();
                        break;
                    case 'yearStart':
                        $_v = explode('-', $education->getStartDate());
                        $value = $_v[0];
                        break;
                    case 'yearEnd':
                        $_v = explode('-', $education->getEndDate());
                        $value = $_v[0];
                        break;
                    default:
                        $methodName = 'get'.ucfirst($fieldName);
                        $value = $education->$methodName();
                        break;
                }
            }
            
            self::$count++;
            return $this->values;
        }
    }
}