<?php

/**
 * Carerix Wordpress Plugin
 *
 * @category settings
 * @author Bogdan Ivanov
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @link http://www.carerix.com
 * @since Aug 29, 2013 9:29:42 AM
 * @version $Rev$
 */


/**
 * Job class
 * Used to ....
 */
class Entity_Writer_Article extends Entity_Writer {
	
	protected $type = WP_Constants::ENTITY_TYPE_ARTICLE;
	
	public function getContent() 
	{
		$labels =  Utils_Labels::get();
		
		$content = '<h3 class=\'cx_h3\'>'.$this->dataDictionary['subtitle'].'</h3>';
		$content .= '<!--more-->';
		$content .= $this->dataDictionary['content'];
		return $content;
	}

	public function getTitle() 
	{
		if(isset($this->dataDictionary['title']))
		{
			return $this->dataDictionary['title'];
		}
		
		return '';
	}
	
	public function getCorrespondentID()
	{
		if(isset($this->dataDictionary['id']))
		{
			return $this->dataDictionary['id'];
		}
		
		return false;
	}
	
	public function getPublishDate()
	{
		if(isset($this->dataDictionary['creationDate']))
		{
			return $this->dataDictionary['creationDate'];
		}
		
		return date('Y-m-d H:i:s');
	}
	
	public function postWrite($post_id)
	{
		// set category
		$categories = array(
                    'Newsletters',
                    $this->dataDictionary['newsletter_name'],
                    $this->dataDictionary['edition_name']
                );
		
                // do translation
		$language = false;
		if($this->interfacer->wpml_is_active())
		{
                    $language = $this->interfacer->language_major_current();
		}
		
		$this->interfacer->entity_link_category($post_id, $categories, $language);
		$this->interfacer->entity_set_property( $post_id, 'edition_id', $this->dataDictionary['edition_id'] );
		$this->interfacer->entity_set_property( $post_id, 'newsletter_id', $this->dataDictionary['newsletter_id'] );
	}

    public function getSlug() {
        return false;
    }
	
}