<?php

// [todo] bring the settings kept in Environment Installation here
class Environment_Settings {
    
    const KEY_FORM_AGREEMENT = 'form_general_agreement';
    const KEY_FORM_AGREEMENT_LABEL = 'form_general_agreement_label';
    const KEY_FORM_AGREEMENT_URL = 'form_general_agreement_url';
    const KEY_FORM_ADRESS_FORMAT = 'form_address_format';
    const KEY_APPLY_OPTIONS_STATUS = 'form_apply_options_status';
    const KEY_APPLY_LOGIN_STATUS = 'form_apply_login_status';
    const KEY_TUTORIAL_STOP = 'tutorial_stop';
    const KEY_APPLY_FORM_CAPTCHA = 'form_apply_captcha';
    const KEY_TAF_CAPTCHA = 'taf_captcha';
    const KEY_AGE_LIMIT = 'form_age_limit';
    const KEY_FORM_GENDER_UNKNOWN = 'form_gender_unknown';
    const KEY_JAS_STATUS = 'jas_captcha';
    const KEY_CLEAN_CATEGORIES = 'sync_clean';
    const KEY_SKIP_MAIN_CATEGORY = 'skip_main_category';
    const KEY_FORM_JOBBOARD = 'jobboard_form';
    
    
    public static function setSyncClean($status) 
    {
        self::_set_setting_unique(self::KEY_CLEAN_CATEGORIES, $status);
    }

     public static function getSyncClean()
    {
        $status = self::_setting_get(self::KEY_CLEAN_CATEGORIES);
        
        if(strtolower(trim($status)) === 'on' || strtolower(trim($status)) === '1') 
            return strtolower(trim($status));
        
        return false;
    }
    
    public static function setSkipMainCategory($status) 
    {
        self::_set_setting_unique(self::KEY_SKIP_MAIN_CATEGORY, $status);
    }
    
    public static function getSkipMainCategory()
    {
        $status = strtolower(trim(self::_setting_get(self::KEY_SKIP_MAIN_CATEGORY)));
        
        if($status === 'on' || $status === '1') {
            return $status;
        }
        
        return false;
    }

    public static function setFormGenderUnknown($status)
    {
        Utils_Cache::cleanEnvironment();
        self::_set_setting_unique(self::KEY_FORM_GENDER_UNKNOWN, $status);
    }
    
    public static function getFormGenderUnknown() {
        return self::_setting_get(self::KEY_FORM_GENDER_UNKNOWN);
    }
    
    public static function getSelectedFormForJobboard() {
        return self::_setting_get(self::KEY_FORM_JOBBOARD);
    }
    
    public static function setSelectedFormForJobboard($form_id) {
        self::_set_setting_unique(self::KEY_FORM_JOBBOARD, $form_id);
    }
    
    public static function setFormGeneralAgreementUrl($url)
    {
        self::_set_setting_unique(self::KEY_FORM_AGREEMENT_URL, $url);
    }

    public static function getFormGeneralAgreementUrl()
    {
        return self::_setting_get(self::KEY_FORM_AGREEMENT_URL);
    }

    public static function setApplyFormCaptchaStatus($status) 
    {
        self::_set_setting_unique(self::KEY_APPLY_FORM_CAPTCHA, $status);
    }
    
    public static function getApplyFormCaptchaStatus()
    {
        return self::_setting_get(self::KEY_APPLY_FORM_CAPTCHA);
    }
            
    public static function setTAFCaptchaStatus($status)
    {
        self::_set_setting_unique(self::KEY_TAF_CAPTCHA, $status);
    }

    public static function getTAFCaptchaStatus()
    {
        return self::_setting_get(self::KEY_TAF_CAPTCHA);
    }
    
    public static function getJASCaptchaStatus()
    {
        return self::_setting_get(self::KEY_JAS_STATUS);
    }
    
    public static function setJASCaptchaStatus($jas_captcha) 
    {
        self::_set_setting_unique(self::KEY_JAS_STATUS, $jas_captcha);
    }

    public static function setFormGeneralAgreement($agreement)
    {
       self::_set_setting_unique(self::KEY_FORM_AGREEMENT, $agreement);
    }
    
    public static function getFormGeneralAgreementLabel()
    {
        return self::_setting_get(self::KEY_FORM_AGREEMENT_LABEL);
    }
    
    public static function setFormGeneralAgreementLabel($label)
    {
        self::_set_setting_unique(self::KEY_FORM_AGREEMENT_LABEL, $label);
    }
    
    public static function getFormGeneralAgreement()
    {
        return self::_setting_get(self::KEY_FORM_AGREEMENT);
    }
    
    public static function setFormAddressFormatGeneral($format)
    {
        self::_set_setting_unique(self::KEY_FORM_ADRESS_FORMAT, $format);
    }
    
    public static function getFormAddressFormatGeneral()
    {
        return self::_setting_get(self::KEY_FORM_ADRESS_FORMAT);
    }
    
    public static function setAgeLimit($age)
    {
        self::_set_setting_unique(self::KEY_AGE_LIMIT, $age);
    }
    
    public static function getAgeLimit()
    {
        return self::_setting_get(self::KEY_AGE_LIMIT);
    }
    
    public static function getFormApplyOptionsStatus()
    {
        return self::_setting_get(self::KEY_APPLY_OPTIONS_STATUS);
    }
    
    public static function setFormApplyOptionsStatus($status)
    {
        self::_set_setting_unique(self::KEY_APPLY_OPTIONS_STATUS, $status);
    }
    
    public static function getLoginLinkStatus()
    {
        return self::_setting_get(self::KEY_APPLY_LOGIN_STATUS);
    }
    
    public static function setLoginLinkStatus($status)
    {
        self::_set_setting_unique(self::KEY_APPLY_LOGIN_STATUS, $status);
    }
    
    public static function setStopTutorial()
    {
        self::_set_setting_unique(self::KEY_TUTORIAL_STOP, Carerix::VERSION);
    }
    
    public static function getStopTutorial()
    {
        $tutorialStatusVersion = self::_setting_get(self::KEY_TUTORIAL_STOP);
        
        if($tutorialStatusVersion != Carerix::VERSION) return false;
        
        return true;
    }
    
    public static function _setting_get($setting_key)
    {
        $settingsTable = new WP_Table(Environment_Installation::TABLE_SETTINGS);
        $agreementRow = $settingsTable->getByKey($setting_key);

        if(count($agreementRow) > 0)
		{
			return $agreementRow[0]['value'];
		}
		
		return '';
    }
    
    public static function _setting_exists($setting_key)
    {
        $settingsTable = new WP_Table(Environment_Installation::TABLE_SETTINGS);
        $agreementRow = $settingsTable->getByKey($setting_key);
        if(count($agreementRow) > 0)
		{
			return (int)$agreementRow[0]['id'];
		}
		
		return FALSE;
    }
    
    public static function _set_setting_unique($key, $value)
    {
        $settingsTable = new WP_Table(Environment_Installation::TABLE_SETTINGS);
        $data = array();
        $data['value'] = $value;
        $data['key'] = $key;

        if(FALSE === $setting_id = self::_setting_exists($key))
        {
            $setting_id = $settingsTable->insert($data);
        }
        else
        {
            $settingsTable->update($setting_id, $data);
        }
        return $setting_id;
    }

    public static function getAppName() {
        return Environment_Installation::getAppName();
    }
    
    public static function getAppToken() {
        return Environment_Installation::getAppToken();
    }

    public static function getAppReporting() {
        return Environment_Installation::getAppReporting();
    }

    public static function setAppName($appName) {
        self::_set_setting_unique('app_name', $appName);
    }

    public static function setAppToken($appToken) {
        self::_set_setting_unique('app_token', $appToken);
    }
    
    public static function setAppReporting($appReporting) {
        self::_set_setting_unique('app_reporting', $appReporting);
    }

    public static function lockTheCron() {
        self::_set_setting_unique('cron_locked', 'yes');
    }
    
    public static function unlockTheCron() {
        self::_set_setting_unique('cron_locked', 'no');
    }
    
    public static function isTheCronLocked() {
        $status = trim(self::_setting_get('cron_locked'));
        
        if($status == 'yes') return true;
        return false;
    }

    
    
}